Bug 54910 - Format %{Foobar}o cannot be used to log Date and Server reply headers
Summary: Format %{Foobar}o cannot be used to log Date and Server reply headers
Status: RESOLVED LATER
Alias: None
Product: Apache httpd-2
Classification: Unclassified
Component: mod_log_config (show other bugs)
Version: 2.2.24
Hardware: All All
: P2 enhancement (vote)
Target Milestone: ---
Assignee: Apache HTTPD Bugs Mailing List
URL:
Keywords: MassUpdate
Depends on:
Blocks:
 
Reported: 2013-04-30 17:19 UTC by Phil Pickett
Modified: 2018-11-07 21:09 UTC (History)
2 users (show)



Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Phil Pickett 2013-04-30 17:19:56 UTC
When using a LogFormat like the following to attempt to log the Server reply header in the access log, no Server header is logged. This is also a problem for the Date reply header but works for others.

LogFormat "%h %l %u %t \"%r\" %>s %b %{Server}o" common

With this LogFormat, the following appears in the access log:

127.0.0.1 - - [01/Mar/2013:09:05:29 -0700] "GET /TCSession/ HTTP/1.1" 200 241 –

I’ve narrowed this down to the following in modules/http/http_filters.c:

/* unset so we don't send them again */
apr_table_unset(r->headers_out, "Date"); /* Avoid bogosity */
apr_table_unset(r->headers_out, "Server");

I found the following related thread in the httpd dev mailing list:

http://httpd.markmail.org/message/7qdntcqiwmfdp73w?q=%22%25{Server}o%22&page=2

I've seen the same behavior in several Apache httpd 2.2/2.4 versions.
Comment 1 Larry West 2014-02-13 19:16:32 UTC
We see this too, in v2.2.22.

FWIW, since we see the Server header passed through to the client, it is not a security setting.

We have a load balancer between HTTPD and the application servers, so listing an identifier for the app server would be a big time-saver for some of our performance investigations.   This bug impedes that.

So, this is a vote for a fix.

Thanks,

Larry West
Comment 2 William A. Rowe Jr. 2018-11-07 21:09:47 UTC
Please help us to refine our list of open and current defects; this is a mass update of old and inactive Bugzilla reports which reflect user error, already resolved defects, and still-existing defects in httpd.

As repeatedly announced, the Apache HTTP Server Project has discontinued all development and patch review of the 2.2.x series of releases. The final release 2.2.34 was published in July 2017, and no further evaluation of bug reports or security risks will be considered or published for 2.2.x releases. All reports older than 2.4.x have been updated to status RESOLVED/LATER; no further action is expected unless the report still applies to a current version of httpd.

If your report represented a question or confusion about how to use an httpd feature, an unexpected server behavior, problems building or installing httpd, or working with an external component (a third party module, browser etc.) we ask you to start by bringing your question to the User Support and Discussion mailing list, see [https://httpd.apache.org/lists.html#http-users] for details. Include a link to this Bugzilla report for completeness with your question.

If your report was clearly a defect in httpd or a feature request, we ask that you retest using a modern httpd release (2.4.33 or later) released in the past year. If it can be reproduced, please reopen this bug and change the Version field above to the httpd version you have reconfirmed with.

Your help in identifying defects or enhancements still applicable to the current httpd server software release is greatly appreciated.